/*
 * American Sign Language Learning Aid (ASLLA),
 * Copyright (C) 2002
 *    andy_uehara@yahoo.com
 * 
 * This program is free software; you can redistribute it and/or modify it
 * under the terms of the GNU General Public License as published by the
 * Free Software Foundation; either version 2 of the License, or (at your
 * option) any later version.
 * 
 * This program is distributed in the hope that it will be useful, but
 * WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
 * General Public License for more details.
 * 
 * You should have received a copy of the GNU General Public License along
 * with this program; if not, write to the Free Software Foundation, Inc.,
 * 675 Mass Ave, Cambridge, MA 02139, USA.
 * 
 */

#include "Csignword.h"

CSignword::CSignword(){
  SurfPtr=NULL;
  RectPtr=&Rect;
  Numframes=Curframe=Initialx=Initialy=Spacingx=Spacingy=0;
  Notes="";
  Name="";
  Filename="";
}

CSignword::~CSignword(){}


/////////////////////////////////////////////////////
////                    Friends
//////////////////////////////////////////////////////

ostream& operator << (ostream& os, const CSignword& s){
  os<<s.GetName()<<" "<<s.GetFilename()<<endl;
  os<<s.GetNotes()<<endl;
  os<<s.GetInitialx()<<" "<<s.GetInitialy()<<" "<<s.GetSpacingx()<<" ";
  os<<s.GetSpacingy()<<" "<<s.GetNumframes()<<endl;
  return os;
}

istream& operator >> (istream& is, CSignword& s){
  cerr<<"istream& operator >> (istream& is, CSignword& s)"<<endl;
  //char ch;
  string input;
  string tmp;
  int ix,iy,sx,sy,nf;
  input="";
  ix=iy=sx=sy=nf=0;
  is>>input;
  s.SetName(input);
  cerr<<"name="<<input<<endl;
  input="";
  is>>input;
  s.SetFilename(input);
  //cerr<<"filename="<<input<<endl;
  input="";
  //is>>ch;
  //  ch=is.get();
  //cin>>tmp;
  tmp="";
  //cerr<<"before while loop"<<endl;
  while (tmp !="*"){
    input+=tmp+" ";
    //cerr<<"tmp "<<tmp<<endl;
    //cerr<<input<<endl;
	is>>tmp;}
  //NEED to figure out a way to get single char input or a line at a time
  //>>input;
  s.SetNotes(input);
  //cerr<<"geting int vals"<<endl;
  is>>ix>>iy>>sx>>sy>>nf;
  s.SetIntvals(ix,iy,sx,sy,nf);
  //cerr<<"returning is"<<endl;
  return is;
}


void CSignword::Initialize(SDL_Surface* s,string sn, string na,string no, int ix,int iy,int sx,int sy, int nf){
  SetFilename(sn);
  SetSurface(s);
  SetName(na);
  SetNotes(no);
  SetIntvals(ix,iy,sx,sy,nf);
}

void CSignword::SetSurface(SDL_Surface* s){
  if (NULL==s)
    cerr<<"CSignword::SetSurface(SDL_Surface* s) s==NULL"<<endl;
  SurfPtr=s;
}

void CSignword::SetFilename(string sn){
  Filename=sn;
}

void CSignword::SetName(string st){
  Name=st;
}

void CSignword::SetNotes(string st){
  Notes=st;
}

void CSignword::SetIntvals(int ix,int iy,int sx,int sy, int nf){
  //need to add check for negative vals
  Initialx=ix;
  Initialy=iy;
  Spacingx=sx;
  Spacingy=sy;
  Numframes=nf;
  set_rct(Rect,Initialx,Initialy,Spacingy,Spacingx);
}

string CSignword::GetFilename()const{
  return Filename;
}

string CSignword::GetName()const{
  return Name;
}

string CSignword::GetNotes()const{
  return Notes;
}

SDL_Surface* CSignword::GetSurface()const{
  if (SurfPtr==NULL)
    cerr<<"CSignword.cc GetSurface() SDL_Surface*==NULL)"<<endl;
  return SurfPtr;
}

SDL_Rect* CSignword::GetRect(){
  //always returns original rect
  Curframe=0;
  set_rct(Rect,Initialx,Initialy,Spacingy,Spacingx);
  return RectPtr;
}

SDL_Rect* CSignword::GetNextRect(){
  Curframe++;
  if (Curframe>Numframes){
    set_rct(Rect,Initialx,Initialy,Spacingy,Spacingx);
    Curframe=0;
  }  else
    set_rct(Rect,Initialx,(Initialy+Curframe*Spacingy),Spacingy,Spacingx);
  return RectPtr;
}

int CSignword::GetInitialx()const{
  return Initialx;
}

int CSignword::GetInitialy()const{
  return Initialy;
}
int CSignword::GetSpacingx()const{
  return Spacingx;
}
int CSignword::GetSpacingy()const{
  return Spacingy;
}
int CSignword::GetNumframes()const{
  return Numframes;
}









