/*
 * American Sign Language Learning Aid (ASLLA),
 * Copyright (C) 2002
 *    andy_uehara@yahoo.com
 * 
 * This program is free software; you can redistribute it and/or modify it
 * under the terms of the GNU General Public License as published by the
 * Free Software Foundation; either version 2 of the License, or (at your
 * option) any later version.
 * 
 * This program is distributed in the hope that it will be useful, but
 * WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
 * General Public License for more details.
 * 
 * You should have received a copy of the GNU General Public License along
 * with this program; if not, write to the Free Software Foundation, Inc.,
 * 675 Mass Ave, Cambridge, MA 02139, USA.
 * 
 */

#ifndef CSignword_h
#define CSignword_h

#include <SDL/SDL.h>
#include <string>
#include "basicsdl.h"

class CSignword{
  //friends
  friend ostream& operator << (ostream&, const CSignword&);
  friend istream& operator >> (istream&, CSignword&);
 public:
  CSignword();
  ~CSignword();

  void Initialize(SDL_Surface*,string filename, string name,string notes,int initialx,int initialy,int spacingx,int spacingy, int numframes);
  void SetSurface(SDL_Surface*);
  void SetFilename(string);
  void SetName(string);
  void SetNotes(string);
  void SetIntvals(int initialx,int initialy,int spacingx,int spacingy, int numframes);

  string GetFilename()const;
  string GetName()const;
  string GetNotes()const;
  int GetInitialx()const;
  int GetInitialy()const;
  int GetSpacingx()const;
  int GetSpacingy()const;
  int GetNumframes()const;
  SDL_Surface* GetSurface()const;
  SDL_Rect* GetRect();
  SDL_Rect* GetNextRect();

 private:
  SDL_Surface* SurfPtr;
  SDL_Rect Rect;
  SDL_Rect* RectPtr;
  string Name;
  string Notes;
  string Filename;
  int Numframes;
  int Curframe;
  int Initialx;
  int Initialy;
  int Spacingx;
  int Spacingy;

};
#endif



