/*
 * American Sign Language Learning Aid (ASLLA),
 * Copyright (C) 2002
 *    andy_uehara@yahoo.com
 * 
 * This program is free software; you can redistribute it and/or modify it
 * under the terms of the GNU General Public License as published by the
 * Free Software Foundation; either version 2 of the License, or (at your
 * option) any later version.
 * 
 * This program is distributed in the hope that it will be useful, but
 * WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
 * General Public License for more details.
 * 
 * You should have received a copy of the GNU General Public License along
 * with this program; if not, write to the Free Software Foundation, Inc.,
 * 675 Mass Ave, Cambridge, MA 02139, USA.
 * 
 */

#ifndef CSignwordcontainer_h
#define CSignwordcontainer_h

#include "Csignword.h"
//#include "Csurfcontainer.h"
#include <vector>
#include <iomanip.h> //for list()
#include <fstream.h> 

class CSignwordcontainer{
  //friends
  friend ostream& operator << (ostream&, const CSignwordcontainer&);
  friend istream& operator >> (istream&, CSignwordcontainer&);

 public:
  CSignwordcontainer();
  ~CSignwordcontainer();

  void AddWord(CSignword*);
  void Clear();
  void DumpFile (string) const;
  void Initialize (string CSwcconf);
  void LoadFile (string);
  void RemWord (string);
  void SetName (string);
  //  void WordSurfaceConnect();

  string GetName() const;
  int GetSize() const;
  CSignword* FindWord (int);
  CSignword* FindWord (string);
  void List();

  //CSurfcontainer Surfcont;

 private:
  string Name;
  vector<CSignword*>::iterator Iter;
  vector<CSignword*> Snwordcont;  
  CSignword* SwordPtr;
};

#endif
