/*
 * American Sign Language Learning Aid (ASLLA),
 * Copyright (C) 2002
 *    andy_uehara@yahoo.com
 * 
 * This program is free software; you can redistribute it and/or modify it
 * under the terms of the GNU General Public License as published by the
 * Free Software Foundation; either version 2 of the License, or (at your
 * option) any later version.
 * 
 * This program is distributed in the hope that it will be useful, but
 * WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
 * General Public License for more details.
 * 
 * You should have received a copy of the GNU General Public License along
 * with this program; if not, write to the Free Software Foundation, Inc.,
 * 675 Mass Ave, Cambridge, MA 02139, USA.
 * 
 */

#include "Csurfcontainer.h"

CSurfcontainer::CSurfcontainer(){}
CSurfcontainer::~CSurfcontainer(){
  Clear();
}
  
/////////////////////////////////////////////////////
////                    Friends
//////////////////////////////////////////////////////

ostream& operator << (ostream& os, const CSurfcontainer& s){
  os<<s.Surfcont.size()<<endl;
  for (unsigned int i=0;i<s.Surfcont.size();i++)
    os<<*(s.Surfcont[i]);
  return os;
}

istream& operator >> (istream& is, CSurfcontainer& s){
  //cerr<<"istream& operator >> (istream& is, CSurfcontainer& s)"<<endl;
  int val;
  CSurfnode* SnodePtr;
  //clear all old data if there is any
  s.Clear();
 
  //read in new data
  is>>val;
  for (int i=0; i<val; i++){
    SnodePtr=new CSurfnode;
    is>>*(SnodePtr);
    s.Surfcont.push_back(SnodePtr);}
  return is;
}


void CSurfcontainer::AddSnode(CSurfnode* n){
  if (NULL==n)
    cerr<<"CSurfcontainer::AddSnode(CSignword* n) -n==NULL!!!"<<endl;
  else
    Surfcont.push_back(n);
}

void CSurfcontainer::Clear(){
   if (Surfcont.size() !=0){
    for (unsigned int i=0;i<Surfcont.size();i++){
      SnodePtr=Surfcont[i];
      if (SnodePtr != NULL)
	delete SnodePtr;}
  }
    Surfcont.clear();
}

void CSurfcontainer::RemSnode (string name){
  //uses delete!!!
  //  cerr<<"CSurfcontainer::RemSnode(string name)"<<endl;
  Iter=Surfcont.begin();
  for (unsigned int i=0;i<=Surfcont.size();i++,Iter++){
    if ((Surfcont[i])->GetName()==name){
      SnodePtr=Surfcont[i];
      delete SnodePtr;
      Surfcont.erase(Iter);
    }
  }
}

void CSurfcontainer::DumpFile (string s) const{
  ofstream DataFile (s.c_str(), ios::out);
  if (!DataFile){
    cerr<<"void CSurfcontainer::DumpFile (string s)"<<endl;
    cerr<<" File"<<s<<" couldn't be opened!"<<endl;
  }
  else{
    DataFile<<*this;
  }
}

void CSurfcontainer::LoadFile(string s){
  ifstream DataFile (s.c_str(), ios::in);
  if (!DataFile){
    cerr<<"void CSurfcontainer::LoadFile(string s)"<<endl;
    cerr<<" File "<<s<<"couldn't be opened!"<<endl;}
  else{
    DataFile>>*this;}
}

int CSurfcontainer::GetSize() const{
  return Surfcont.size();
}

SDL_Surface* CSurfcontainer::FindSurface (string name){
  SnodePtr=FindSnode(name);
  if (NULL==SnodePtr)
    return NULL;
  return SnodePtr->GetSurface();
}

CSurfnode* CSurfcontainer::FindSnode (string name){
  //does a linear search for the name
  for (unsigned int i=0;i!=Surfcont.size(); i++)
    if ((Surfcont[i])->GetName()==name)
      return Surfcont[i];
  return NULL;
}

void CSurfcontainer::List(){
  //lists all the commands in it's memory
  cerr<<"LIST OF SURFACES"<<endl;
  for (unsigned int i=0; i!=Surfcont.size();i++){
    cerr<<setw(2)<<i<<" "<<setw(10)<<(Surfcont[i])->GetName();
    if ((i+1)%5==0)
      cerr<<endl;
  }
  if ((Surfcont.size())%5!=5)
    cerr<<endl;
}


