/*
 * American Sign Language Learning Aid (ASLLA),
 * Copyright (C) 2002
 *    andy_uehara@yahoo.com
 * 
 * This program is free software; you can redistribute it and/or modify it
 * under the terms of the GNU General Public License as published by the
 * Free Software Foundation; either version 2 of the License, or (at your
 * option) any later version.
 * 
 * This program is distributed in the hope that it will be useful, but
 * WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
 * General Public License for more details.
 * 
 * You should have received a copy of the GNU General Public License along
 * with this program; if not, write to the Free Software Foundation, Inc.,
 * 675 Mass Ave, Cambridge, MA 02139, USA.
 * 
 */

#ifndef CSurfcontainer_h
#define CSurfcontainer_h

#include "Csurfnode.h"
#include <vector>
#include <string>
#include <iomanip.h> //for list() 
#include <fstream.h> 

class CSurfcontainer{
  //friends
  friend ostream& operator << (ostream&, const CSurfcontainer&);
  friend istream& operator >> (istream&, CSurfcontainer&);

 public:
  CSurfcontainer();
  ~CSurfcontainer();

  void AddSnode(CSurfnode*);
  void Clear ();
  void RemSnode (string);
  void LoadFile (string);
  void DumpFile (string) const;
  int GetSize() const;
  CSurfnode* FindSnode (string);
  SDL_Surface* FindSurface (string);
  void List();
 private:
  vector<CSurfnode*>::iterator Iter;
  vector<CSurfnode*> Surfcont;  
  CSurfnode* SnodePtr;
};

#endif
