/*
 * American Sign Language Learning Aid (ASLLA),
 * Copyright (C) 2002
 *    andy_uehara@yahoo.com
 * 
 * This program is free software; you can redistribute it and/or modify it
 * under the terms of the GNU General Public License as published by the
 * Free Software Foundation; either version 2 of the License, or (at your
 * option) any later version.
 * 
 * This program is distributed in the hope that it will be useful, but
 * WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
 * General Public License for more details.
 * 
 * You should have received a copy of the GNU General Public License along
 * with this program; if not, write to the Free Software Foundation, Inc.,
 * 675 Mass Ave, Cambridge, MA 02139, USA.
 * 
 */

#include "Csurfnode.h"

CSurfnode::CSurfnode(){
  SurfPtr=&Surf;
  Name="";
}

CSurfnode::~CSurfnode(){}


/////////////////////////////////////////////////////
////                    Friends
//////////////////////////////////////////////////////

ostream& operator << (ostream& os, const CSurfnode& s){
  os<<s.GetName()<<" "<<s.GetLocation()<<endl;
  return os;
}

istream& operator >> (istream& is, CSurfnode& s){
  //  cerr<<"istream& operator >> (istream& is, CSurfnode& s)"<<endl;
  string input,input2;
  is>>input;
  is>>input2;
  s.Initialize(input2,input);
  return is;
}

void CSurfnode::Initialize(string s,string st){
  SetSurface(s);
  SetLocation(s);
  SetName(st);
}

void CSurfnode::SetSurface(string s){
  set_img(s.c_str(),Surf);
}

void CSurfnode::SetSurface(char* ch){
  set_img(ch,Surf);
}

void CSurfnode::SetName(string s){
  Name=s;
}

void CSurfnode::SetLocation(string s){
  Location=s;
}

SDL_Surface* CSurfnode::GetSurface(){
  return SurfPtr;
}

string CSurfnode::GetName()const{
  return Name;
}

string CSurfnode::GetLocation()const{
  return Location;
}
