/*
 * American Sign Language Learning Aid (ASLLA),
 * Copyright (C) 2002
 *    andy_uehara@yahoo.com
 * 
 * This program is free software; you can redistribute it and/or modify it
 * under the terms of the GNU General Public License as published by the
 * Free Software Foundation; either version 2 of the License, or (at your
 * option) any later version.
 * 
 * This program is distributed in the hope that it will be useful, but
 * WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
 * General Public License for more details.
 * 
 * You should have received a copy of the GNU General Public License along
 * with this program; if not, write to the Free Software Foundation, Inc.,
 * 675 Mass Ave, Cambridge, MA 02139, USA.
 * 
 */

#ifndef CSurfnode_h
#define CSurfnode_h

#include <SDL/SDL.h>
#include <string>
#include "basicsdl.h"
#include <fstream.h>
#include <iostream.h>

//want to get rid of this
//#define FINGERSPELL_DIR(X) "data/fingerspell/" X

class CSurfnode{
  //friends
  friend ostream& operator << (ostream&, const CSurfnode&);
  friend istream& operator >> (istream&, CSurfnode&);

 public:
  CSurfnode();
  ~CSurfnode();

  //may need to add SetSurface string and then add that func to basicsdl 
  void Initialize(string,string);
  void SetSurface(string);
  void SetSurface(char*);
  void SetName(string);
  void SetLocation(string);

  SDL_Surface* GetSurface();
  string GetName()const;
  string GetLocation()const;
 private:
  SDL_Surface Surf;
  SDL_Surface* SurfPtr;
  string Name;
  string Location;
};

#endif
