/*
 * American Sign Language Learning Aid (ASLLA),
 * Copyright (C) 2002
 *    andy_uehara@yahoo.com
 * 
 * This program is free software; you can redistribute it and/or modify it
 * under the terms of the GNU General Public License as published by the
 * Free Software Foundation; either version 2 of the License, or (at your
 * option) any later version.
 * 
 * This program is distributed in the hope that it will be useful, but
 * WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
 * General Public License for more details.
 * 
 * You should have received a copy of the GNU General Public License along
 * with this program; if not, write to the Free Software Foundation, Inc.,
 * 675 Mass Ave, Cambridge, MA 02139, USA.
 * 
 */

#ifndef CTranslator_h
#define CTranslator_h

#include "Csignwordcontainer.h"
#include <vector>
#include <iomanip.h> //for list()
#include <fstream.h> 

class CTranslator{
  //friends
  friend ostream& operator << (ostream&, const CTranslator&);
  friend istream& operator >> (istream&, CTranslator&);

 public:
  CTranslator();
  ~CTranslator();

  void AddSwordcont(CSignwordcontainer*);
  void Clear();
  void DumpFile (string) const;
  void Initialize (string Ctransconf);
  void LoadFile (string);
  void RemSwordcont (string);

  int GetSize() const;
  CSignwordcontainer* GetSwordcont();
  CSignwordcontainer* FindSwordcont (int);
  CSignwordcontainer* FindSwordcont (string);
  //use findword (needs FindSwordcont to work first) 
  //to find the word then FindWord
  CSignword* FindWord(string);//dependent on Findswordcont
  void List();

 private:
  vector<CSignwordcontainer*>::iterator Iter;
  vector<CSignwordcontainer*> Transvec;  
  CSignwordcontainer* CswordcontPtr;
};

#endif
