/*
 * American Sign Language Learning Aid (ASLLA),
 * Copyright (C) 2002
 *    andy_uehara@yahoo.com
 * 
 * This program is free software; you can redistribute it and/or modify it
 * under the terms of the GNU General Public License as published by the
 * Free Software Foundation; either version 2 of the License, or (at your
 * option) any later version.
 * 
 * This program is distributed in the hope that it will be useful, but
 * WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
 * General Public License for more details.
 * 
 * You should have received a copy of the GNU General Public License along
 * with this program; if not, write to the Free Software Foundation, Inc.,
 * 675 Mass Ave, Cambridge, MA 02139, USA.
 * 
 */

#include "basicsdl.h"

void set_bmp(char* bmpname,SDL_Surface& surf){
  SDL_Surface* tmpptr;
  tmpptr= SDL_LoadBMP(bmpname);
  if (tmpptr==NULL){
    cerr<<"set_bmp tmpptr==nULL bmp="<<bmpname<<endl;
    exit(1);}
  surf =*(SDL_DisplayFormat(tmpptr));
  SDL_FreeSurface(tmpptr);
}

void set_bmp(char* bmpname,SDL_Surface& surf,bool h){
  // set colorkey to bright magenta 
  SDL_Surface* tmpptr;
  tmpptr= SDL_LoadBMP(bmpname);
  if (tmpptr==NULL){
    cerr<<"set_bmp tmpptr==nULL bmp="<<bmpname<<endl;
    exit(1);}
  surf =*(SDL_DisplayFormat(tmpptr));
  if (h)
    SDL_SetColorKey(&surf,SDL_SRCCOLORKEY|SDL_RLEACCEL,
		    SDL_MapRGB((&surf)->format,255,0,255));
  SDL_FreeSurface(tmpptr);
}

void set_bmp(const char* bmpname,SDL_Surface& surf){
  SDL_Surface* tmpptr;
  tmpptr= SDL_LoadBMP(bmpname);
  if (tmpptr==NULL){
    cerr<<"set_bmp tmpptr==nULL bmp="<<bmpname<<endl;
    exit(1);}
  surf =*(SDL_DisplayFormat(tmpptr));
  SDL_FreeSurface(tmpptr);
}

void set_bmp(const char* bmpname,SDL_Surface& surf,bool h){
  // set colorkey to bright magenta 
  SDL_Surface* tmpptr;
  tmpptr= SDL_LoadBMP(bmpname);
  if (tmpptr==NULL){
    cerr<<"set_bmp tmpptr==nULL bmp="<<bmpname<<endl;
    exit(1);}
  surf =*(SDL_DisplayFormat(tmpptr));
  if (h)
    SDL_SetColorKey(&surf,SDL_SRCCOLORKEY|SDL_RLEACCEL,
		    SDL_MapRGB((&surf)->format,255,0,255));
  SDL_FreeSurface(tmpptr);
}

void set_img(const char* bmpname,SDL_Surface& surf){
  SDL_Surface* tmpptr;
  tmpptr= IMG_Load(bmpname);
  if (tmpptr==NULL){
    cerr<<"set_bmp tmpptr==nULL bmp="<<bmpname<<endl;
    exit(1);}
  surf =*(SDL_DisplayFormat(tmpptr));
  SDL_FreeSurface(tmpptr);
}

void set_img(char* bmpname,SDL_Surface& surf,bool h){
  // set colorkey to bright magenta 
  SDL_Surface* tmpptr;
  tmpptr= IMG_Load(bmpname);
  if (tmpptr==NULL){
    cerr<<"set_bmp tmpptr==nULL bmp="<<bmpname<<endl;
    exit(1);}
  surf =*(SDL_DisplayFormat(tmpptr));
  if (h)
    SDL_SetColorKey(&surf,SDL_SRCCOLORKEY|SDL_RLEACCEL,
		    SDL_MapRGB((&surf)->format,255,0,255));
  SDL_FreeSurface(tmpptr);
}

void set_rct(SDL_Rect& r,int x,int y,int h,int w){
  r.x=x;
  r.y=y;
  r.h=h;
  r.w=w;
}

void set_rct(SDL_Rect& a,SDL_Rect* b){
  a.x=b->x;
  a.y=b->y;
  a.h=b->h;
  a.w=b->w;
}

void set_rct(SDL_Rect* a,SDL_Rect* b){
  a->x=b->x;
  a->y=b->y;
  a->h=b->h;
  a->w=b->w;
}

void cerr_rct(SDL_Rect* a){
  cerr<<"x="<<a->x<<" y="<<a->y<<" h="<<a->h<<" w="<<a->w<<endl;
}

bool IsSameRect(SDL_Rect* a, SDL_Rect* b){
  if ((a==NULL)||(b==NULL)){
    cerr<<"basicsdl:: issamerect a or b is null"<<endl;
    return false;}
  if ((a->x!=b->x)||(a->y!=b->y))
    return false;
  return true;
}


bool IsWithinRect(SDL_Rect* a,int x,int y){
  if ((a->x<=x)&&((a->x+a->w)>=x))
    if ((a->y<=y)&&((a->y+a->h)>=y))
      return true;
  return false;
}

bool IsWithinRect(SDL_Rect* a,SDL_Rect* b){
  //this also detects overlap as well
  if ((a->x<=b->x)&&((a->x+a->w)>=b->x))
    if ((a->y<=b->y)&&((a->y+a->h)>=b->y))
      return true;
  return false;
}










