/*
 * American Sign Language Learning Aid (ASLLA),
 * Copyright (C) 2002
 *    andy_uehara@yahoo.com
 * 
 * This program is free software; you can redistribute it and/or modify it
 * under the terms of the GNU General Public License as published by the
 * Free Software Foundation; either version 2 of the License, or (at your
 * option) any later version.
 * 
 * This program is distributed in the hope that it will be useful, but
 * WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
 * General Public License for more details.
 * 
 * You should have received a copy of the GNU General Public License along
 * with this program; if not, write to the Free Software Foundation, Inc.,
 * 675 Mass Ave, Cambridge, MA 02139, USA.
 * 
 */

#ifndef BASIC_SDL_h
#define BASIC_SDL_h
#include <SDL/SDL.h>
#include <SDL/SDL_image.h>
#include <iostream.h>

void set_bmp(char* bmpname,SDL_Surface& surf);
void set_bmp(char* bmpname,SDL_Surface& surf, bool h);
void set_bmp(const char* bmpname,SDL_Surface& surf);
void set_bmp(const char* bmpname,SDL_Surface& surf, bool h);
void set_img(const char* bmpname,SDL_Surface& surf);
void set_img(char* bmpname,SDL_Surface& surf,bool h);

void set_rct(SDL_Rect& r,int x,int y,int h,int w);
void set_rct(SDL_Rect& a,SDL_Rect* b);
void set_rct(SDL_Rect* a,SDL_Rect* b);
void cerr_rct(SDL_Rect* a);

bool IsSameRect(SDL_Rect* a, SDL_Rect* b);
bool IsWithinRect(SDL_Rect* a,int x,int y);
bool IsWithinRect(SDL_Rect* a,SDL_Rect* b);

bool Blit_strip (SDL_Surface* a,int offsets,int totallen);

#endif



