/*
 * American Sign Language Learning Aid (ASLLA),
 * Copyright (C) 2002
 *    andy_uehara@yahoo.com
 * 
 * This program is free software; you can redistribute it and/or modify it
 * under the terms of the GNU General Public License as published by the
 * Free Software Foundation; either version 2 of the License, or (at your
 * option) any later version.
 * 
 * This program is distributed in the hope that it will be useful, but
 * WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
 * General Public License for more details.
 * 
 * You should have received a copy of the GNU General Public License along
 * with this program; if not, write to the Free Software Foundation, Inc.,
 * 675 Mass Ave, Cambridge, MA 02139, USA.
 * 
 */
#include "mywidget.h"

MyWidget::MyWidget(PG_Widget* parent,const PG_Point& p,const char* filename) : PG_Image(parent, p,filename, "default") {
  numf=framenum=0;
  SDLrctptr=NULL;
  PGreditptr=NULL;
  SizeWidget(100,100);
}

MyWidget::~MyWidget() {
    // here we could do some cleanup
}

void MyWidget::SetNumF(int n){
  if (n<0)
    numf=0;
  else
    numf=n;
}

void MyWidget::SetFrameNum(int n){
  if (n<0)
    framenum=0;
  else
    framenum=n;
}

void MyWidget::SetSurf(SDL_Surface* s){
  if (s==NULL)
    cerr<<"MYWidget->setsurf s==null"<<endl;
  my_srfScreen=s;
}

void MyWidget::SetSDLRect(SDL_Rect* r){
  if (r==NULL)
    cerr<<"MYWidget->SetSDLRect r=NULL"<<endl;
  SDLrctptr=r;
}

void MyWidget::LoadSignWord(CSignword* signwdptr){
  LoadImage((signwdptr->GetFilename()).c_str());
  SetNumF(signwdptr->GetNumframes());
  SetSDLRect(signwdptr->GetRect());
  SetFrameNum(0);
  //cerr<<" signwdptr->GetNotes() "<<signwdptr->GetNotes()<<endl;
  //PROBLEM PGreditptr doesn't handle strings correctly yet
  //produces a doubled last word at the end of the string
  if (PGreditptr!=NULL){
    PGreditptr->SetText(signwdptr->GetNotes());
    //const char * test=signwdptr->GetNotes().c_str();
    //cerr<<" test="<<test<<endl;
    //PGreditptr->SetText(test);
    PGreditptr->Update(true);
    }
  Update(true);
}

void MyWidget::SetPGRedit(PG_RichEdit* re){
  if (re==NULL)
    cerr<<"MyWidget::SetPGRedit re==NULL"<<endl;
  PGreditptr=re;
}

void MyWidget::PlayWord(){
  for (int i=framenum;i<=numf;i++){
    //    cerr<<"PLAYWORD framnum="<<framenum;
    //cerr<<" numframe="<<numf<<endl;
    SDL_Delay (100);
    Update(true);
  }
  framenum=0;
}
void MyWidget::PlayWord(int time){
  for (int i=framenum;i<=numf;i++){
    //    cerr<<"PLAYWORD framnum="<<framenum;
    //cerr<<" numframe="<<numf<<endl;
    SDL_Delay (time);
    Update(true);
  }
  framenum=0;
}
void MyWidget::eventBlit (SDL_Surface* surface, const PG_Rect& rect, const PG_Rect& rect2) {
  if (framenum>numf)
    framenum=0;
  if (SDLrctptr !=NULL){
    PG_Rect tmprct(*SDLrctptr);
    if (framenum!=0){
      //      cerr<<"MODIFIED TMPRCT"<<endl;
      tmprct.my_ypos=(framenum*100)+SDLrctptr->y;}
    /*
    cerr<<"numf="<<numf<<" framenum="<<framenum<<endl;
    cerr<<"framenumrct="<<tmprct.my_xpos<<" "<<tmprct.my_ypos<<" ";
    cerr<<tmprct.my_width<<" "<<tmprct.my_height<<endl;
    */
    PG_Widget::eventBlit(my_image,tmprct,rect2);
    framenum++;
  }
}






