/*
 * American Sign Language Learning Aid (ASLLA),
 * Copyright (C) 2002
 *    andy_uehara@yahoo.com
 * 
 * This program is free software; you can redistribute it and/or modify it
 * under the terms of the GNU General Public License as published by the
 * Free Software Foundation; either version 2 of the License, or (at your
 * option) any later version.
 * 
 * This program is distributed in the hope that it will be useful, but
 * WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
 * General Public License for more details.
 * 
 * You should have received a copy of the GNU General Public License along
 * with this program; if not, write to the Free Software Foundation, Inc.,
 * 675 Mass Ave, Cambridge, MA 02139, USA.
 * 
 */
#ifndef Cmywidget_h
#define Cmywidget_h

#include "pgapplication.h"
#include "pgbutton.h"
#include "pglabel.h"
#include "pgimage.h"
#include "pgthemewidget.h"
#include "pgeventobject.h"
#include "pglineedit.h"
#include "pgrichedit.h"

#include "Csignword.h"

class MyWidget :public PG_Image {
public:
  MyWidget(PG_Widget* parent,const PG_Point& p,const char* filename);
  ~MyWidget();
  void SetNumF(int);
  void SetSurf(SDL_Surface*);
  void SetFrameNum(int);
  void SetSDLRect(SDL_Rect*);
  void SetPGRedit(PG_RichEdit*);
  void LoadSignWord(CSignword*);
  void PlayWord();
  void PlayWord(int);
protected:
  // our custom event handler to redraw our stuff
  void eventBlit (SDL_Surface* surface, const PG_Rect& rect, const PG_Rect& rect2);
private:
  PG_RichEdit* PGreditptr;
  SDL_Rect* SDLrctptr;
  int numf;
  int framenum;
};
#endif
