/*
 * American Sign Language Learning Aid (ASLLA),
 * Copyright (C) 2002
 *    andy_uehara@yahoo.com
 * 
 * This program is free software; you can redistribute it and/or modify it
 * under the terms of the GNU General Public License as published by the
 * Free Software Foundation; either version 2 of the License, or (at your
 * option) any later version.
 * 
 * This program is distributed in the hope that it will be useful, but
 * WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
 * General Public License for more details.
 * 
 * You should have received a copy of the GNU General Public License along
 * with this program; if not, write to the Free Software Foundation, Inc.,
 * 675 Mass Ave, Cambridge, MA 02139, USA.
 * 
 */

#include "paragui.h"
#include "pgpopupmenu.h"
#include "pgdropdown.h"
#include "pgrichedit.h"
#include "pgmenubar.h"

#include "mydropbox.h"
#include "mydropbox2.h"
#include "Ctranslator.h"
CTranslator translator;

PARAGUI_CALLBACK(exit_handler) {
    PG_Application* app = (PG_Application*) clientdata;
    app->Quit();
    return true;
}

PARAGUI_CALLBACK(show_handler) {
    MyWidget* wid = (MyWidget*) clientdata;
    wid->Update(true);
    return true;
}

PARAGUI_CALLBACK(play_handler) {
    MyWidget* wid = (MyWidget*) clientdata;
    wid->PlayWord();
    return true;
}

//PARAGUI_CALLBACK

int main(int argc, char* argv[]) {
    PG_Application app;

    app.LoadTheme("default");
    app.InitScreen(240, 320, 16, SDL_SWSURFACE);
    app.SetCaption("American Sign Language Learning Aid (ASLLA)",NULL);

    PG_RichEdit redit(NULL,PG_Rect(0,260,240,60),false,220,30,10,"WidgetList");
    redit.SetText("This is where notes will appear");
    redit.Show();

    PG_Label myLabel(NULL,PG_Rect(0,0,240,20),"Dictionary",NULL);
    myLabel.Show();
    PG_Point pnt;
    pnt.x=0;
    pnt.y=91;
    MyWidget myWid(NULL,pnt, "data/asl/dne.jpg");
    myWid.SetPGRedit(&redit);
    myWid.Update(true);
    myWid.Show();

    PG_Button myButton(NULL,1, PG_Rect(180, 0, 60, 20), "Quit");
    myButton.SetEventCallback(MSG_BUTTONCLICK, exit_handler, &app);
    myButton.Show();
    PG_Button myButton2(NULL,2,PG_Rect(0,200, 240, 30), "Show Frame by Frame");
    myButton2.SetEventCallback(MSG_BUTTONCLICK, show_handler, &myWid);
    myButton2.Show();
    PG_Button myButton3(NULL,3,PG_Rect(0,230,240,30), "Play Entire Clip");
    myButton3.SetEventCallback(MSG_BUTTONCLICK, play_handler, &myWid);
    myButton3.Show();
    
    //need to add something to check for return null case
    translator.Initialize("data/trans.conf");
    translator.FindSwordcont("asl");    

    MyDropBox2 drop2(NULL,15,PG_Rect(0,20,240,30));
    drop2.SetTranslator(&translator);
    drop2.SetMyWid(&myWid);
    drop2.SetText("select or enter a word");
    drop2.Show();

    MyDropBox drop(NULL,14,PG_Rect(0,50,240,30));
    drop.SetTranslator(&translator);
    drop.SetDropbox2(&drop2);
    drop.SetEditable(false);
    drop.SetText("pick a language :asl");
    //matches above translator default setting
    drop.Show();



    app.Run();
    return 0;
}








