/*
 * American Sign Language Learning Aid (ASLLA),
 * Copyright (C) 2002
 *    andy_uehara@yahoo.com
 * 
 * This program is free software; you can redistribute it and/or modify it
 * under the terms of the GNU General Public License as published by the
 * Free Software Foundation; either version 2 of the License, or (at your
 * option) any later version.
 * 
 * This program is distributed in the hope that it will be useful, but
 * WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
 * General Public License for more details.
 * 
 * You should have received a copy of the GNU General Public License along
 * with this program; if not, write to the Free Software Foundation, Inc.,
 * 675 Mass Ave, Cambridge, MA 02139, USA.
 * 
 */
#include "mydropbox.h"

MyDropBox::MyDropBox(PG_Widget *parent, int id, const PG_Rect &r, const char *style="DropDown"):PG_DropDown(parent,id,r,style){
  translatorptr=NULL;
  drpbx2ptr=NULL;
  my_DropList->SetMultiSelect(false);
}

MyDropBox::~MyDropBox(){}

void MyDropBox::SetTranslator (CTranslator* tptr){
  if (tptr==NULL)
    cerr<<"MyDropBox::SetTranslator tptr==NULL"<<endl;
  translatorptr=tptr;
  LoadTranslatorDB();
}

void MyDropBox::SetDropbox2(MyDropBox2* dptr){
  if (dptr==NULL)
    cerr<<"MydropBox::SetDropbox2 dptr==NULL"<<endl;
  drpbx2ptr=dptr;
}

void MyDropBox::LoadTranslatorDB (){
  CSignwordcontainer* Cswcptr;
  char* name;
  if (translatorptr!=NULL){
    for (int i=0;i<translatorptr->GetSize();i++){
      Cswcptr=translatorptr->FindSwordcont (i);
      name=(char*)(Cswcptr->GetName()).c_str();
      AddItem(name,name);
    }
  }
}

bool MyDropBox::eventSelectItem(PG_ListBoxBaseItem *item){
  cerr<<"In MYDROPBOX::eventselectItem"<<endl;
  cerr<<"data="<<(char *)item->GetUserData()<<endl;
  char* data=(char *)item->GetUserData();
  char* oldname=(char*)(translatorptr->GetSwordcont()->GetName()).c_str();
  cerr<<"old swdcont="<<oldname<<endl;
  if (strcmp(oldname,data) !=0){
    translatorptr->FindSwordcont(data);
    drpbx2ptr->LoadCSignwrdcntrDB();
  }
  SetText(data);
  
  return true;
}
