/*
 * American Sign Language Learning Aid (ASLLA),
 * Copyright (C) 2002
 *    andy_uehara@yahoo.com
 * 
 * This program is free software; you can redistribute it and/or modify it
 * under the terms of the GNU General Public License as published by the
 * Free Software Foundation; either version 2 of the License, or (at your
 * option) any later version.
 * 
 * This program is distributed in the hope that it will be useful, but
 * WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
 * General Public License for more details.
 * 
 * You should have received a copy of the GNU General Public License along
 * with this program; if not, write to the Free Software Foundation, Inc.,
 * 675 Mass Ave, Cambridge, MA 02139, USA.
 * 
 */

#ifndef Cmydropbox_h
#define Cmydropbox_h
#include "pgapplication.h"
#include "pgbutton.h"
#include "pglabel.h"
#include "pgimage.h"
#include "pgthemewidget.h"
#include "pgeventobject.h"
#include "pglineedit.h"
#include "pgdropdown.h"

#include "Ctranslator.h"
#include "mydropbox2.h"

//need to try and fix eventselectitem
//b/c it currently delete's the entire list
//I want it to replace the names and mydropbox2.Additem only when needed
//this would probably be faster too
//dynamic creation/deletion vs. renaming/adding to entire list
class MyDropBox :public PG_DropDown{
public:
  MyDropBox(PG_Widget *parent, int id, const PG_Rect &r, const char *style="DropDown");
  ~MyDropBox();
  void SetTranslator (CTranslator*);
  void SetDropbox2(MyDropBox2*);
  void LoadTranslatorDB ();
  bool eventSelectItem(PG_ListBoxBaseItem *item);
protected:
private:
  MyDropBox2* drpbx2ptr;
  CTranslator* translatorptr;
};
#endif
