/*
 * American Sign Language Learning Aid (ASLLA),
 * Copyright (C) 2002
 *    andy_uehara@yahoo.com
 * 
 * This program is free software; you can redistribute it and/or modify it
 * under the terms of the GNU General Public License as published by the
 * Free Software Foundation; either version 2 of the License, or (at your
 * option) any later version.
 * 
 * This program is distributed in the hope that it will be useful, but
 * WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
 * General Public License for more details.
 * 
 * You should have received a copy of the GNU General Public License along
 * with this program; if not, write to the Free Software Foundation, Inc.,
 * 675 Mass Ave, Cambridge, MA 02139, USA.
 * 
 */

#include "mydropbox2.h"

PARAGUI_CALLBACK(drop_handler){
  MyDropBox2* mdb2=(MyDropBox2*) clientdata;
  mdb2->EnterHandler();
  return true;
}

MyDropBox2::MyDropBox2(PG_Widget *parent, int id, const PG_Rect &r, const char *style="DropDown"):PG_DropDown(parent,id,r,style){
  translatorptr=NULL;
  mywidptr=NULL;
  my_DropList->SetMultiSelect(false);
  my_EditBox->SetEventCallback(MSG_RETURN,drop_handler,this);
  my_EditBox->SetValidKeys("qwertyuiopasdfghjklzxcvbnm1234567890QWERTYUIOPASDFGHJKLZXCVBNM/- ");
}

MyDropBox2::~MyDropBox2(){}

void MyDropBox2::SetTranslator (CTranslator* tptr){
  if (tptr==NULL)
    cerr<<"MyDropBox::SetTranslator tptr==NULL"<<endl;
  translatorptr=tptr;
  LoadCSignwrdcntrDB();
}

void MyDropBox2::LoadCSignwrdcntrDB(){
  CSignwordcontainer* Cswcptr;
  CSignword* Cswdptr;
  char* name;
  if (translatorptr!=NULL){
    DeleteAll();
    Cswcptr=translatorptr->GetSwordcont();
    if (Cswcptr!= NULL){
      for (int i=0;i<Cswcptr->GetSize();i++){
	Cswdptr=Cswcptr->FindWord (i);
	name=(char*)(Cswdptr->GetName()).c_str();
	AddItem(name,name);
      }
    }
  }
}

bool MyDropBox2::eventSelectItem(PG_ListBoxBaseItem *item){
  //cerr<<"In MYDROPBOX2::eventselectItem"<<endl;
  //cerr<<"data="<<(char *)item->GetUserData()<<endl;
  char * data=(char *)item->GetUserData();
  LoadMywid(data);
  SetText(data);
  return true;
}

void MyDropBox2::SetMyWid(MyWidget* mw){
  if (mw ==NULL)
    cerr<<"MyDropBox setmywid() mw==null!"<<endl;
  else
    mywidptr=mw;
}

void MyDropBox2::LoadMywid(char* word){
  //cerr<<"MyDropBox2.LoadMywid word="<<word<<endl;
  CSignword* SwPtr=translatorptr->FindWord(word);
  if (SwPtr==NULL)
    cerr<<"MYLINEE.print SwPtr==NULL!!"<<endl;
  else {
    //may want to add check for repetitive fileloading aka fingerspell case
    //cerr<<" filename: "<<SwPtr->GetFilename()<<endl;
    //cerr<<"mywidptr=="<<&mywidptr<<endl;
    mywidptr->LoadSignWord(SwPtr);
  }
}

void MyDropBox2::EnterHandler(){
  LoadMywid((char *)GetText());
}

MyWidget* MyDropBox2::GetMyWid(){
  return mywidptr;
}










