/*
 * American Sign Language Learning Aid (ASLLA),
 * Copyright (C) 2002
 *    andy_uehara@yahoo.com
 * 
 * This program is free software; you can redistribute it and/or modify it
 * under the terms of the GNU General Public License as published by the
 * Free Software Foundation; either version 2 of the License, or (at your
 * option) any later version.
 * 
 * This program is distributed in the hope that it will be useful, but
 * WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
 * General Public License for more details.
 * 
 * You should have received a copy of the GNU General Public License along
 * with this program; if not, write to the Free Software Foundation, Inc.,
 * 675 Mass Ave, Cambridge, MA 02139, USA.
 * 
 */
#include "Cmediator.h"

CMediator::CMediator(){
  WrdLstPtr=NULL;
  PgLineEPtr=NULL;
  CtransPtr=NULL;
  CswdCntPtr=NULL;
  MyWidPtr=NULL;
  PgSpinPtr=NULL;
  guessword="";
  DelayVal=500;
}

CMediator::~CMediator(){}

void CMediator::SetWrdLst(CWordlist* w){
  if (w==NULL)
    cerr<<"CMediator::SetWrdLst w==NULL"<<endl;
  WrdLstPtr=w;
}

void CMediator::SetPGLineE(PG_LineEdit* l){
  if (l==NULL)
    cerr<<"CMediator::SetPGLineE l==NULL"<<endl;
  PgLineEPtr=l;
}

void CMediator::SetPGSpinner(PG_SpinnerBox* s){
  if (s==NULL)
    cerr<<"CMediator::SetPGSpinner s==NULL"<<endl;
  PgSpinPtr=s;
}

void CMediator::SetMyWidget(MyWidget* m){
  if (m==NULL)
    cerr<<"CMediator::SetMyWidget m==NULL"<<endl;
  MyWidPtr=m;
}

void CMediator::SetTranslator(CTranslator* t){
  if (t==NULL)
    cerr<<"CMediator::SetTranslator t==NULL"<<endl;
  CtransPtr=t;
}

void CMediator::SetCSnWdCont(CSignwordcontainer* c){
  if (c==NULL)
    cerr<<"CMediator::SetCSnWdCont c==NULL"<<endl;
  CswdCntPtr=c;
}

void CMediator::ChangeRandomWord(){
  guessword=WrdLstPtr->GetRandWord();
  PgLineEPtr->SetText(guessword.c_str());
  PgLineEPtr->Hide();
}

void CMediator::PlayGuessWord(){
  string test="";
  CSignword* SwPtr;
  //cerr<<"CMediator::PlayGuessword Guessword="<<guessword<<endl;
  for (unsigned int i=0;i<guessword.size();i++){
    //test+(char)tolower(guessword[i])
    //I use this because string class doesn't handle chars nicely
    //so instead of passing a char I pass a string
    //cerr<<" "<<test+(char)tolower(guessword[i])<<" ";
    SwPtr=CswdCntPtr->FindWord((test+(char)tolower(guessword[i])));
    MyWidPtr->LoadSignWord(SwPtr);
    MyWidPtr->PlayWord();
    SDL_Delay(DelayVal);
  }
  //cerr<<endl;
}

void CMediator::UpdateDelay(){
  //cerr<<"old delay="<<DelayVal<<" ";
  int tmp;
  tmp=PgSpinPtr->GetValue();
  DelayVal=tmp*100;
  //cerr<<"new delay="<<DelayVal<<endl;
}




