/*
 * American Sign Language Learning Aid (ASLLA),
 * Copyright (C) 2002
 *    andy_uehara@yahoo.com
 * 
 * This program is free software; you can redistribute it and/or modify it
 * under the terms of the GNU General Public License as published by the
 * Free Software Foundation; either version 2 of the License, or (at your
 * option) any later version.
 * 
 * This program is distributed in the hope that it will be useful, but
 * WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
 * General Public License for more details.
 * 
 * You should have received a copy of the GNU General Public License along
 * with this program; if not, write to the Free Software Foundation, Inc.,
 * 675 Mass Ave, Cambridge, MA 02139, USA.
 * 
 */
#ifndef CMediator_h
#define CMediator_h

#include <ctype.h>
#include <string>

#include "Cwordlist.h"
#include "Ctranslator.h"
#include "mywidget.h"

#include "paragui.h"
#include "pglineedit.h"
#include "pgspinnerbox.h"

class CMediator{
 public:
  CMediator();
  ~CMediator();

  void SetWrdLst(CWordlist*);
  void SetPGLineE(PG_LineEdit*);
  void SetPGSpinner(PG_SpinnerBox*);
  void SetMyWidget(MyWidget*);
  void SetTranslator(CTranslator*);
  void SetCSnWdCont(CSignwordcontainer*);

  //PG -> my class interactin functions
  void ChangeRandomWord();
  void PlayGuessWord();
  void UpdateDelay();
 private:
  MyWidget* MyWidPtr;
  PG_SpinnerBox* PgSpinPtr;
  PG_LineEdit* PgLineEPtr;
  CWordlist* WrdLstPtr;
  CTranslator* CtransPtr;
  CSignwordcontainer* CswdCntPtr;
  int DelayVal;
  string guessword;
};

#endif
    




