/*
 * American Sign Language Learning Aid (ASLLA),
 * Copyright (C) 2002
 *    andy_uehara@yahoo.com
 * 
 * This program is free software; you can redistribute it and/or modify it
 * under the terms of the GNU General Public License as published by the
 * Free Software Foundation; either version 2 of the License, or (at your
 * option) any later version.
 * 
 * This program is distributed in the hope that it will be useful, but
 * WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
 * General Public License for more details.
 * 
 * You should have received a copy of the GNU General Public License along
 * with this program; if not, write to the Free Software Foundation, Inc.,
 * 675 Mass Ave, Cambridge, MA 02139, USA.
 * 
 */
#include "Cwordlist.h"

CWordlist::CWordlist(){
#ifndef SRANDOM
#define SRANDOM
  srand(time(NULL));
#endif
}

CWordlist::~CWordlist(){}

/////////////////////////////////////////////////////
////                    Friends
//////////////////////////////////////////////////////
//NOTE BOTH Friend classes don't call any surfcont. functions

ostream& operator << (ostream& os, const CWordlist& w){
  os<<w.Words.size()<<endl;
  for (unsigned int i=0;i<w.Words.size();i++)
    os<<w.Words[i];
  return os;
}

istream& operator >> (istream& is, CWordlist& w){
  //cerr<<"istream& operator >> (istream& is, CWordslist& w)"<<endl;
  string data;
  w.Words.clear();
  
  //read in new data
  while(is>>data)
    w.Words.push_back(data);
  return is;
}

//////////////////////////////////////////////////////
//                      Member funcs
////////////////////////////////////////////////////

void CWordlist::Initialize (string filename){
  LoadFile(filename.c_str());
}

void CWordlist::DumpFile (string s) const{
  ofstream DataFile (s.c_str(), ios::out);
  if (!DataFile){
    cerr<<"void CWordlist::DumpFile (string s)"<<endl;
    cerr<<" File"<<s<<" couldn't be opened!"<<endl;
  }
  else{
    DataFile<<*this;
  }
}

void CWordlist::LoadFile(string s){
  ifstream DataFile (s.c_str(), ios::in);
  if (!DataFile){
    cerr<<"void CWordlist::LoadFile(string s)"<<endl;
    cerr<<" File "<<s<<" couldn't be opened!"<<endl;}
  else{
    DataFile>>*this;}
}

int CWordlist::GetSize() const{
  return Words.size();
}

string CWordlist::GetRandWord() {
  int num;
  num=rand()%Words.size();
  return Words[num];
}

void CWordlist::Print(){
  cout<<"LIST OF WORDS"<<endl;
  for (unsigned int i=0; i!=Words.size();i++)
    cout<<Words[i]<<" ";
  cout<<endl<<Words.size()<<endl;
}











