/*
 * American Sign Language Learning Aid (ASLLA),
 * Copyright (C) 2002
 *    andy_uehara@yahoo.com
 * 
 * This program is free software; you can redistribute it and/or modify it
 * under the terms of the GNU General Public License as published by the
 * Free Software Foundation; either version 2 of the License, or (at your
 * option) any later version.
 * 
 * This program is distributed in the hope that it will be useful, but
 * WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
 * General Public License for more details.
 * 
 * You should have received a copy of the GNU General Public License along
 * with this program; if not, write to the Free Software Foundation, Inc.,
 * 675 Mass Ave, Cambridge, MA 02139, USA.
 * 
 */
#ifndef CWordlist_h
#define CWordlist_h

#include <string>
#include <deque>
#include <time.h>
#include <stdlib.h>
#include <fstream.h>

class CWordlist{
  friend ostream& operator << (ostream&, const CWordlist&);
  friend istream& operator >> (istream&, CWordlist&);

 public:
  CWordlist();
  ~CWordlist();

  void DumpFile (string) const;
  void Initialize (string);
  void LoadFile (string);

  string GetRandWord();
  int GetSize() const;
  void Print();

 private:
  deque<string> Words;
  int num;
};
#endif
